import { getManifest, Product } from 'ssn';
import IProductData from './interfaces/IProductData';
import writeLog from './logger/writeLog';
import * as database from './model/database';
import * as model from './model/model';

//create lock file to prevent conflicts?

const newPatches: any[] = [];

(async function() {
  const productData: { [key in Product]?: IProductData } = await model.init();
  const productDataEntries = Object.entries(productData) as Array<[Product, IProductData]>;

  await Promise.all(productDataEntries.map(async ([product, { manifest, http}]) => {
    //Check for new manifest version
    const { current } = await getManifest(product);
    if (current < manifest) {
      writeLog(`Product ${product} now has a smaller manifest version ${current}, down from ${manifest}.`);
      return;
    }
    if (current > manifest) {
      writeLog(`New manifest version: ${current} instead of ${manifest}`);
      model.updateManifestVersion(product, current);
    }

    //Check for new HTTP version
    //TODO
  }));

  database.exit();
}());

/*//for each product, check new versions
Object.entries(products).forEach(([product, { manifestVersion, httpVersion }]: [string, IDatabaseRow]) => {
  const curVersion = 100;
  //Check patch to next release
  for (let i = curVersion; i < curVersion + 3; i += 1) {
    getSolidpkg(product as Product, i, i + 1).then((result) => {
      console.log(result);
      newPatches.push({ product, version: i, result });
    }).catch(() => {
      //do nothing
    });
  }
  //TODO
});*/

//parse results
//TODO: need to wait for all promises to be complete

//if new version was found, try to install it

//also check manifest in case a new version is available for installation. remember time when patch became available for installation but otherwise do nothing

//delete lock file
